
#include <iostream>
#include <vector>
using namespace std;

vector<vector<double>> vs = {
     {10,11,12,13,14},             // OK: vector of five elements
     {10},                         // OK: vector of one element
//     10,                           // error: vector<double>(int) is explicit
     vector<double>{10,11,12,13},  // OK: vector of five elements
     vector<double>{10},           // OK: vector of one element with value 10.0
     vector<double>(10),           // OK: vector of 10 elements with value 0.0
};

vector<int> v2(10,1); // 10 items with value 1

vector<int> v3{10,1}; // 2 items

vector<double> v4{10,1}; // 2 items, converted

//vector<bool> v5{10,1}; // 2 items, error: narrowing conversion

int main() {
    cout << "vs.size()=" << vs.size() << endl;
    cout << "v2.size()=" << v2.size() << endl;
    cout << "v3.size()=" << v3.size() << endl;
}
