
#include <initializer_list>
#include <typeinfo>
#include <iostream>

template<typename T>
std::ostream& operator<<(std::ostream& ostr, const std::initializer_list<T>& c)
{
    for (auto &i : c) {
        ostr << " " << i;
    }
    return ostr;
}

int main() {
    auto l1 = {5,1,2,3};
    auto l2 = {5,1,2,3};

    std::swap(l1,l2);

    std::cout << "l1=" << l1 << '\n';
    std::cout << "l2=" << l2 << '\n';
    std::cout << '\n';
    std::cout << "typeid = " << typeid(l1).name() << '\n';
}
