
// C++17: structured bindings example

#include <iostream>
#include <map>

int main() {

    std::map<int,const char*> m { {1,"a"}, {2,"b"}, };

    for( auto && [key,value] : m ) {    // &&: forwarding reference
        std::cout << key << ": " << value << "\n";
    }

}
