// 2exception.cc -- tda Vector -- pole s kontrolou indexu

#include <iostream>
using namespace std;

class Vector {
  int *p;
  int sz;
 public:
  Vector() : sz(10) { p = new int[sz]; }
  class Range {};  // tda vjimky
  int &operator[] (int i) {
    if(i>=0 && i<sz) return p[i];
    throw Range();
  }
  // ....
};


void f(Vector &v) {
  // ....
  try {
    // 'hldan' oblast
    v[11] = 5;
    // ....
  }
  catch(Vector::Range) {
    // obsluha vjimky Vector::Range (exception handler)
    // tento kd se provede jen kdy se v sekci try vyskytne
    // index mimo rozsah
    cout << "exception Vector::Range A" << endl;
  }
  // ....
}

void ff(Vector &v) {
  try {
    f(v); // funkce f obsluhuje vjimku Vector::Range
  }
  catch(Vector::Range) {
    // tento kd se nikdy neprovede protoe ppadn vjimka je
    // pln obslouena uvnit funkce f
    cout << "exception Vector::Range B" << endl;
  }
}

int main() {
  Vector v;
  ff(v);
}

