// max.cc -- ablony funkc, generick funkce (function templates)

#include <string.h>

template <class T>
T max(T x, T y) {               // ablona funkce max
  return (x>y)?x:y;
}

char *max(char *x, char *y) {   // speciln ppad
  return (strcmp(x,y)>0) ? x : y;
}

class MyClass { // pokusn tda
  int i;
 public:
  MyClass(int x=0) : i(x) {}
  bool operator > (MyClass x) { return i > x.i; }
};

int main() {
  int i, j;                // neinicializovan promnn
  MyClass a, b, m;
  char *s1="abc";
  char *s2="qwerty";
  char *s3;

  j  = max(i,0);           // typ int
  m  = max(a,b);           // typ MyClass
  s3 = max(s1,s2);         // string

  return 0;
}

void f(int i, char c) {
  max(i,i);  // vol max(int,int)
  max(c,c);  // vol max(char,char)
//  max(i,c);  // nen funkce max(int,char)  - chyba!
//  max(c,i);  // nen        max(char,int)  - chyba!
}
