// mem.cc -- alokace pamti a vjimky

#include <iostream>
using namespace std;

template<class T> 
class MemPtr { // ablona pro bezpen uvolovn pamti pi vjimce
  T *p;
 public:
  MemPtr(size_t s)  { p = new T[s]; cout << "new\n"; }
  ~MemPtr()  { delete [] p; cout << "delete\n"; }
  operator T* ()  { return p; }
};

class X {
  MemPtr<int> cp; // zajist alokaci/dealokaci pamti
 public:
  X(int s): cp(s) { init(); }
  void init() {
#if 1
    cout << "throw int(1)\n";
    throw int(1); // lep je definovat tdu 
#endif
  }
};

// main -- ukzka obsluhy vjimek
int main() try {
  X a(10);
  return 0;
}
catch(int i) {
  cout << "error: " << i << endl;
}


