
#include <random>
#include <iostream>

int main() {
    std::random_device seed;               // random generator
    std::default_random_engine R{seed()};  // pseudorandom generator
    std::cout << seed() << "\n";
    std::cout << R() << "\n";
    std::cout << "uniform int 1..6: \t";
    std::cout << std::uniform_int_distribution{1,6}(R) << "\n";
    std::cout << "exponential mean=1: \t";
    std::cout << std::exponential_distribution{1.0}(R) << "\n";
}
