
#include <iostream>
#include <chrono>
 
int main()
{
    using namespace std::chrono_literals;
    auto d1 = 250us;
    std::chrono::microseconds d2 = 1ms;
    std::cout << "250us = " << d1.count() << " microseconds\n"
              << "1ms = " << d2.count() << " microseconds\n";

    auto day = 24h;
    auto halfhour = 0.5h;
    std::cout << "one day is " << day.count() << " hours\n"
              << "half an hour is " << halfhour.count() << " hours\n";

    auto lesson = 45min;
    auto halfmin = 0.5min;
    std::cout << "one lesson is " << lesson.count() << " minutes\n"
              << "half a minute is " << halfmin.count() << " minutes\n";

    auto halfmin2 = 30s;
    std::cout << "half a minute is " << halfmin2.count() << " seconds\n"
              << "a minute and a half is " << (1min + 30s).count() << " seconds\n";

    auto d3 = 250ns;
    std::chrono::nanoseconds d4 = 1us;
    std::cout << "250ns = " << d3.count() << " nanoseconds\n"
              << "1us = " << d4.count() << " nanoseconds\n";

}

