
// test of 0-1 user defined conversion in search for possible ways

struct A {
    A() {}
    A(const A&) {}
};

struct B {
    B(){}
    B(const B&){}
    operator A() { return A(); }
};

struct C {
    C(){}
    operator B() { return B(); } // not used for C->B->A conversion
    //operator A() { return A(); } // will work with this
};

// test
int main() {
    C c;
#ifdef ERR
    A a = c;    // error: no C->A conversion
#endif
}

