// p4 -- doplnn vstupu 

#include <iostream>
#include <cstdlib>         // exit()

using namespace std;

void error(const char *msg) {           // hlen chyb
  cerr << "Chyba: " << msg << endl;
  exit(1);
}

class Interval_1_10 {
  int n;
 public:
  Interval_1_10() { n = 1; }            // implicitn konstruktor 
  Interval_1_10(int n) { SetValue(n); } // 
  void SetValue(int x) {                // nastaven hodnoty
    if(x<1 || x>10) error("Mimo rozsah");
    n = x;
  }
  int GetValue() { return n; }
  friend ostream & operator << (ostream &s, const Interval_1_10 &x);
};

ostream &operator << (ostream &s, const Interval_1_10 &x) {
  s << x.n;
  return s;
}

int main() {                 // testy ...
  Interval_1_10 x;           // implicitn konstruktor
  Interval_1_10 y(5);        // konstruktor s parametrem int

  cout << x << endl;         // tiskne 1
  cout << y << endl;         // tiskne 5
  x = y;
  cout << x << endl;         // tiskne 5
}

