// ref.cc -- typ reference

#include <iostream>
using namespace std;

int &f(int &x) { // pedn odkazem, vrac odkaz
  x += 5;
  return x; // pozor na existenci objektu na kter se odkazuje
            // (nelze pout automatickou promnnou, protoe zanikne)
}

void g(const int &x) { // pedn odkazem, nelze modifikovat x
  // x += 5; // chyba
  cout << "f(const int &x): " << " x = " << x << endl;
}

int main() {
  int a = 10;
  int &r = a;        // reference na a
  const int &r2 = 2; // pomocn promnn (pozor na dobu jej existence!)
  cout << "r = " << r << ", a = " << a << endl;
  f(a);              // pedn parametru odkazem
  cout << "r = " << r << ", a = " << a << endl;
  int b = f(a);      // pouit vsledku funkce
  cout << "r = " << r << ", a = " << a << ", b = " << b << endl;
  f(a) = 0;          // modifikace a pes vrcen odkaz
  cout << "r = " << r << ", a = " << a << endl;
  g(5);    
  g(r2);
  return 0;
} // zde zanik pomocn promnn pro r2

